package de.ipk.pdwexpress.util;

import java.sql.SQLException;
import java.util.Collection;

import de.ipk.pdwexpress.upload.PE_Object;

public interface PE_ObjectsWrapper<T extends PE_Object> {

	/**
	 * @return the items
	 */
	public Collection<T> getItems();

//	public void addItems(List<T> newItems);

	/**
	 * Excutes saveObject method for all objects within the wrapper
	 * @throws SQLException If saveObject throws SQLException;
	 */
	public void saveAll() throws SQLException;

	/**
	 * Searches for a PE_Object with the given parameters.
	 * 
	 * @param acc The acc to search.
	 * @return List with found Objects. NULL if nothing was mapped.
	 * 
	 * @throws NullPointerException If acc or db is NULL
	 */
	public Collection<T> getByIdentifier(String acc);

	/**
	 * Returns the first value returned by getByIdentifier
	 * @param acc
	 * @return The PE_Object, NULL if nothing was found.
	 */
	public T getFirstByIdentifier(String acc);

	/**
	 * Searches for a PE_Object with the given parameters.
	 * 
	 * @param name The name to search.
	 * 
	 * @return List with found Objects. NULL if nothing was mapped.
	 * 
	 * @throws NullPointerException If acc or db is NULL
	 */
	public Collection<T> getByName(String name);

	/**
	 * Returns the first value returned by getByName
	 * @param name
	 * @return The PE_Object, NULL if nothing was found.
	 */
	public T getFirstByName(String name);

}